library(Rcapture)
suppressPackageStartupMessages(library(tidyverse))

get_abundance <- function(df) {
  dat <- closedpCI.0(df, t = Inf, m = "Mh", h = "LB")
  res <- dat$CI
  return(as.data.frame(res))
}
get_abundance_eta <- function(df) {
  dat <- closedpCI.0(df, m = "Mh", h = "LB")
  res <- dat$CI
  return(as.data.frame(res))
}

get_abundance_ll <- function(df) {
  dat <- closedpCI.t(df, mX = "[12,13,14,23,5]")
  res <- dat$CI
  return(as.data.frame(res))
}

rcapture.df <- function(df, positive_selection = 1) {
  pos.df <- df %>% filter(positive == positive_selection)
  rcapture.df <- pos.df %>%
    select(!ends_with("positive")) %>%
    select(starts_with("learner") | matches("count"))
  return(rcapture.df)
}

rasch.csv <- function(filename) {
  # For reading the csv files with matrices
  # when manually reading and testing.
  # Usage: df <- rasch.csv("design_matrix_11.csv")
  df <- read_csv(filename, col_types = cols(X1 = col_skip()))
  return(df)
}

rasch_to_abundance <- function(df) {
  rcp.df <- rcapture.df(df)
  result <- closedpCI.0(rcp.df, dfreq = TRUE, t = Inf, m = "Mh", h = "LB")
  return(result)
}

library(Rcapture)
library(tidyverse)

get_abundance <- function(df){
    dat <- closedpMS.t(df)
    res <- dat$results
    return(as.data.frame(res))
}

rcapture.df <- function(df, positive_selection=1){
    pos.df <- df %>% filter(positive == positive_selection)
    rcapture.df  <- pos.df %>%
      select(!ends_with("positive")) %>%
      select(starts_with("learner") | matches("count"))
    return(rcapture.df)
}

rasch.csv <- function(filename){
  # For reading the csv files with matrices 
  # when manually reading and testing.
  # Usage: df <- rasch.csv("design_matrix_11.csv")
  df <- read_csv(filename, col_types = cols(X1= col_skip()))
  return(df)
}

rasch_to_abundance <- function(df){
  rcp.df <- rcapture.df(df)
  result <- closedpCI.0(rcp.df,dfreq = TRUE, t = Inf, m = "Mh", h = "LB")
  return(result)
}

library(tidyverse)

df.modify <- function(freq.df, n.pos, n.neg){
  # From Python the rows for n_00...0 are missing
  # We add them with the following statement
  df <- freq.df %>% 
    add_row(count=n.pos, positive=1) %>%
    add_row(count=n.neg, positive=0) %>%
    mutate_at(vars(-c("count")), ~replace(., is.na(.), 0))
  return(df)
}

rasch.bf.comb <- function(freq.df, N,proportion=0.1, tolerance=1e-5){
  # Calculate the number of documents that are not read
  count.found <- sum(freq.df$count)
  N0 <- N - sum(freq.df$count) 
  # Calculate the start values for the n.pos and n.neg
  deviances <- list()
  models <- list()
  estimates <- list()
  model.min <- glm(count ~ ., "poisson", df.modify(freq.df, 0, N0))
  deviance.min <- Inf
  for(i in 0:N0){
    n.pos <- i
    n.neg <- N0 - i
    df <- df.modify(freq.df, n.pos, n.neg)
    model <- glm(count ~ ., "poisson", df)
    if(deviance.min > model$deviance){
      deviance.min <- model$deviance
      model.min <- model
    }
    estimate <- fitted(model) %>% 
                  unlist(use.names=F) %>% 
                  as.vector() %>% 
                  tail(2) %>% head(1)
    models[[(i+1)]] <- model
    deviances[[(i+1)]] <- model$deviance
    estimates[[(i+1)]] <- estimate
  }
  ret <- list(
    model.min = model.min,
    models = models,
    deviances = (deviances %>% unlist(use.names = F) %>% as.vector()),
    estimates = (estimates %>% unlist(use.names = F) %>% as.vector())
  )
  return(ret)
}

rasch.bf.table <- function(result){
  x <- (1:length(result$deviances)) - 1
  df <- data.frame(
    n.pos = x,
    deviance = result$deviances,
    estimate = result$estimates ,
    difference = result$estimates - x
  )
  return(df)
}




rasch.csv <- function(filename){
  # For reading the csv files with matrices 
  # when manually reading and testing.
  # Usage: df <- rasch.csv("matrix3_iteration_11.csv")
  df <- read_csv(filename, col_types = cols(X1= col_skip()))
  return(df)
}
rasch.em.horizon <- function(freq.df, # The dataframe (from python or rasch.csv)
                             N, # The dataset size 
                             proportion=0.1){ # Initial ratio of positive documents
  # This is the function that is called from Python
  # Gather the positive part of the table
  df.pos <- freq.df %>% filter(positive==1)
  # Calculate the number of positive documents
  count.found <- sum(df.pos$count)
  model <- rasch.em.comb(freq.df, N, proportion=proportion)
  fv <- fitted(model) %>% unlist(use.names=F) %>% as.vector()
  # Estimates for n00...0 are located at the last two members of the list
  estimates <-  tail(fv, 2)
  # Return the estimated number of positive documents
  df <- data.frame(estimate=count.found + estimates[1])
  return(df)
}

get_rasch <- function(df){
  model <- glm(
    formula = count ~ ., 
    family = poisson(link = "log"), 
    data = df
  )
  coefficients = coef(model)
  stderrs = sqrt(diag(vcov(model)))
  intercept = coefficients[1]
  intercept.err = stderrs[1]
  estimate.missing = exp(intercept)
  estimate.stderr = exp(intercept.err)
  df <- data.frame(
    estimate = c(estimate.missing),
    stderr = c(estimate.stderr))
  return(df)
}

library(purrr)

rasch.single <- function(df, epsilon=0.1){
  # Copy the Frequency Table to a new variable
  count.df <- df
  # Add a small amount $\epsilon$ to the counts to migitate
  # explosion of estimates
  count.df$count <- count.df$count + epsilon
  # Estimate the Rasch model
  model <- glm(
    formula = count ~ ., 
    family = poisson(link = "log"), 
    data = count.df
  )
  # Get the coefficients from the model
  coefficients <- coef(model) %>% unlist(use.names = F)
  stderrs = sqrt(diag(vcov(model))) %>% unlist(use.names = F)
  
  # Get the intercept of the formula (the estimate is exp(intercept))
  intercept = coefficients[1]
  intercept.err = stderrs[1]
  
  # Calculate the estimate
  estimate.missing = exp(intercept)
  estimate.stderr = exp(intercept.err)
  
  # Construct a dataframe that contains the results 
  results <- data.frame(
    estimate = c(estimate.missing),
    stderr = c(estimate.stderr))
  return(results)
}

rasch.single.model <- function(df, epsilon=0.1){
  # Copy the Frequency Table to a new variable
  count.df <- df
  # Add a small amount $\epsilon$ to the counts to migitate
  # explosion of estimates
  count.df$count <- count.df$count + epsilon
  # Estimate the Rasch model
  model <- glm(
    formula = count ~ ., 
    family = poisson(link = "log"), 
    data = count.df
  )
  # Get the coefficients from the model
  coefficients <- coef(model) %>% unlist(use.names = F)
  stderrs = sqrt(diag(vcov(model))) %>% unlist(use.names = F)
  
  # Get the intercept of the formula (the estimate is exp(intercept))
  intercept = coefficients[1]
  intercept.err = stderrs[1]
  
  # Calculate the estimate
  estimate.missing = exp(intercept)
  estimate.stderr = exp(intercept.err)
  
  # Construct a dataframe that contains the results 
  results <- list(
    estimate = estimate.missing,
    stderr = estimate.stderr,
    model=model)
  return(results)
}


rasch.nonparametric <- function(df, it=2000, confidence=0.95, epsilon=0.1){
  count.found <- sum(df$count)
  counts.orig <- df$count + epsilon
  counts.bootstrap <- rmultinom(it, count.found, counts.orig)
  # Estimate n_00...0 using the Rasch model
  estimate.missing <- rasch.single(df, epsilon=epsilon)$estimate
  estimates <- list()
  for (col.idx in 1:dim(counts.bootstrap)[2]) {
    count.bootstrap <- counts.bootstrap[,col.idx]
    df.adjusted <- df
    df.adjusted$count <- count.bootstrap
    model.results <- rasch.single(df.adjusted)
    estimates[[col.idx]] <- model.results$estimate
  }
  # Determine using the percentile method a 
  # 95% confidence interval
  results <- unlist(estimates, use.names = F)
  sorted <- sort(results)
  bounds <- unlist(quantile(sorted, c(1-confidence, confidence)), use.names=F)
  result.df <- data.frame(
    estimate = c(count.found + estimate.missing),
    lowerbound = c(count.found + bounds[1]),
    upperbound = c(count.found + bounds[2])
  )
  return(result.df)
}

rasch.parametric <- function(df, it=2000, confidence=0.95, epsilon=0.1){
  # Copy the Frequency Table to a new variable
  count.df <- df
  count.found <- sum(count.df$count)
  # Estimate n_00...0 using the Rasch model
  main.model <- rasch.single.model(df, epsilon)$estimate
  # Gather the counts of all rows and add the estimation for n_00..0
  counts.model <- append(df$count, main.model)
  counts.model.sum <- sum(counts.model)
  # Sample with replacement of size n from this multinomial distribution. 
  # Remove the observation that correspond with cell 00..0. 
  counts.bootstrap <- rmultinom(it, 
                                counts.model.sum, 
                                counts.model) %>% head(-1)
  # Calculate the n_00...0 for all the bootstrap counts
  estimates <- list()
  for (col.idx in 1:dim(counts.bootstrap)[2]) {
    count.bootstrap <- counts.bootstrap[,col.idx]
    df.adjusted <- df
    df.adjusted$count <- count.bootstrap
    model.results <- rasch.single(df.adjusted)
    estimates[[col.idx]] <- model.results$estimate
  }
  # Determine using the percentile method a 
  # 95% confidence interval
  results <- unlist(estimates, use.names = F)
  sorted <- sort(results)
  bounds <- unlist(quantile(sorted, c(1-confidence, confidence)), use.names=F)
  result.df <- data.frame(
    estimate = c(count.found + main.model),
    lowerbound = c(count.found + bounds[1]),
    median = c(count.found + median(sorted)), 
    upperbound = c(count.found + bounds[2])
  )
  rownames(result.df) <- NULL
  return(result.df)
}

library(tidyverse)

df.modify <- function(freq.df, n.pos, n.neg){
  # From Python the rows for n_00...0 are missing
  # We add them with the following statement
  df <- freq.df %>% 
    add_row(count=n.pos, positive=1) %>%
    add_row(count=n.neg, positive=0) %>%
    mutate_at(vars(-c("count")), ~replace(., is.na(.), 0))
  return(df)
}

rasch.em.comb <- function(freq.df, N, proportion=0.1, tolerance=1e-5){
  # Calculate the number of documents that are not read
  N0 <- N - sum(freq.df$count) # N0  <- N - sum(d$Freq[s])
  # Calculate the start values for the n.pos and n.neg
  n.pos <- proportion*N0 
  n.neg <- (1-proportion)*N0
  
  # Add the missing rows for n_00...0
  df <- df.modify(freq.df, n.pos, n.neg)
  s <- c(
    rep(T, nrow(freq.df)), # Do not contain n_00...0
    rep(F, nrow(df) - nrow(freq.df)) #Do contain n_00...0
  )
  
  # Copy the data frame to new variable that can be manipulated
  df.em <- df 
  
  # Fit initial log linear model and calculate deviance
  mstep   <- glm(count ~ ., "poisson", df.em)
  devold  <- mstep$deviance
  tol <- devold
  
  while(tol > tolerance){
    # Calculate fitted frequencies
    mfit  <- fitted(mstep, "response")
    
    # Adjust the frequencies for n_00...0
    efit  <- df.em$count
    efit[!s] <- mfit[!s] * N0 / sum(mfit[!s]) 
    
    # Store new frequencies in data frame
    df.em$count <- efit
    
    # Fit log linear model and calculate deviance
    mstep <- glm(count ~ ., "poisson", df.em, start=coef(mstep))
    devnew <- mstep$deviance
    
    # Determine if we have converged
    tol <- abs(devold - mstep$deviance)
    devold <- mstep$deviance
  }
  return(mstep)
}


rasch.em.comb.conv <- function(freq.df, N, proportion=0.1, tolerance=1e-5){
  # Calculate the number of documents that are not read
  N0 <- N - sum(freq.df$count) # N0  <- N - sum(d$Freq[s])
  # Calculate the start values for the n.pos and n.neg
  n.pos <- proportion*N0 
  n.neg <- (1-proportion)*N0
  
  # Add the missing rows for n_00...0
  df <- df.modify(freq.df, n.pos, n.neg)
  s <- df %>% 
    select(!ends_with("positive")) %>% 
    select(starts_with("learner")) %>% 
    rowwise() %>% 
    mutate(
      selection=(sum(c_across(starts_with("learner"))) > 0)) %>% 
    select("selection") %>% 
    unlist() %>% 
    as.vector()
  s.pos <- df$positive == 1 & !s
  s.neg <- df$positive == 0 & !s
  
  # Copy the data frame to new variable that can be manipulated
  df.em <- df 
  
  # Fit initial log linear model and calculate deviance
  mstep   <- glm(count ~ ., "poisson", df.em)
  mfit.old <- fitted(mstep, "response")
  devold  <- mstep$deviance
  tol <- devold
  
  while(tol > tolerance){
    # Calculate fitted frequencies
    mfit  <- fitted(mstep, "response")
    
    # Adjust the frequencies for n_00...0
    efit  <- df.em$count
    efit[!s] <- mfit[!s] * N0 / sum(mfit[!s]) 
    
    # Store new frequencies in data frame
    df.em$count <- efit
    
    # Fit log linear model and calculate deviance
    mstep <- glm(count ~ ., "poisson", df.em)
    devnew <- mstep$deviance
    
    # Determine if we have converged
    tol <- abs(mfit[s.pos] - efit[s.pos])
    mfit.old <- mfit
  }
  return(mstep)
}

L2 <- function(b0, lambda = 0, D, counts, N) {
  tol <- 1
  tolerance <- 1e-8
  while (tol > tolerance) {
    mu   <- exp(D %*% b0)
    db   <- crossprod(D, counts) - crossprod(D, mu) - 2 * c(0, lambda * b0[-1])
    I    <- crossprod(D, diag(c(mu))) %*% D + 2 * diag(c(0, rep(lambda, length(b0) - 1)))
    invI <- tryCatch(solve(I), error = function(e) e)
    if(inherits(invI, "error")){
      lambda <- g(lambda)
      next
    }
    b <- b0 + invI %*% db
    tol  <- sum(abs(b0 - b))
    b0   <- b
  }
  return(b)
}

calc.dev <- function(y, yhat){
  2 * sum(y[y > 0] * log(y[y > 0] / yhat[y > 0]), na.rm = T) - 2 * sum(y - yhat, na.rm = T)
}
g <- function(x){
  ifelse(x == 0, 1e-6, 10 * x)
}



rasch.ridge.em.comb <- function(freq.df, N, proportion=0.1, tolerance=1e-5){
  N0 <- N - sum(freq.df$count) # N0  <- N - sum(d$Freq[s])
  # Calculate the start values for the n.pos and n.neg
  n.pos <- proportion*N0 
  n.neg <- (1-proportion)*N0
  
  # Add the missing rows for n_00...0
  df <- df.modify(freq.df, NA, NA) %>% 
    arrange(positive, rev(across(starts_with("learner")))) %>%
    add_column(intercept=1, .before="learner_0")
  df.mat <- df %>% select(-count)
  s <- df %>% 
    select(!ends_with("positive")) %>% 
    select(starts_with("learner")) %>% 
    rowwise() %>% 
    mutate(
      selection=(sum(c_across(starts_with("learner"))) > 0)) %>% 
    select("selection") %>% 
    unlist() %>% 
    as.vector()
  s.pos <- df$positive == 1 & !s
  s.neg <- df$positive == 0 & !s
  D <- as.matrix(df.mat)
  efit     <- df$count
  efit[s.pos] <- n.pos
  efit[s.neg] <- n.neg
  beta     <- L2(
    b0 = c(log(N), rep(0, ncol(D) - 1)), 
    D = D, N = N, counts = efit
  )
  devold   <- calc.dev(df$count, exp(D %*% beta))
  tol      <- 1
  while(tol > tolerance){
    mfit     <- exp(D %*% beta)
    efit[!s] <- mfit[!s] * N0 / sum(mfit[!s]) 
    beta     <- L2(b0 = beta, D = D, N = N, counts = efit)
    devnew   <- calc.dev(df$count, exp(D %*% beta))
    tol      <- devold - devnew
    devold   <- devnew
  }
  p <- as.list(mfit) %>% unlist()
  W <- diag(p)
  cvm <- solve(t(D) %*% W %*% D)
  SE <- sqrt(diag(cvm))
  ret <- list(
    coefficients=beta,
    fitted=mfit,
    deviance=devold,
    est.pos=mfit[s.pos,1],
    est.neg=mfit[s.neg,1],
    std.err = SE,#SE,
    cvm = cvm#cvm
  )
  return(ret)
}

Vcov.glm = function(object, dispersion = NULL, ...) {
  if (p <- len(coefficients)) {
    dispersion = 1
    p1 = seq_len(p)
    nm <- names(object$coefficients[object$qr$pivot[p1]])
    covmat = dispersion * chol2inv(object$qr$qr[p1, p1, drop = FALSE])
    dimnames(covmat) = list(nm, nm)
    return(covmat)
  } else return(numeric(0))
}




rasch.csv <- function(filename){
  # For reading the csv files with matrices 
  # when manually reading and testing.
  # Usage: df <- rasch.csv("matrix3_iteration_11.csv")
  df <- read_csv(filename, col_types = cols(X1= col_skip()))
  return(df)
}
rasch.em.horizon <- function(freq.df, # The dataframe (from python or rasch.csv)
                             N, # The dataset size 
                             proportion=0.1){ # Initial ratio of positive documents
  # This is the function that is called from Python
  # Gather the positive part of the table
  df.pos <- freq.df %>% filter(positive==1)
  # Calculate the number of positive documents
  count.found <- sum(df.pos$count)
  model <- rasch.em.comb(freq.df, N, proportion=proportion)
  fv <- fitted(model) %>% unlist(use.names=F) %>% as.vector()
  # Estimates for n00...0 are located at the last two members of the list
  estimates <-  tail(fv, 2)
  # Return the estimated number of positive documents
  df <- data.frame(estimate=count.found + estimates[1])
  return(df)
}

rasch.em.bootstrap.horizon <- function(freq.df, # The dataframe (from python or rasch.csv)
                             N, # The dataset size 
                             proportion=0.5, it=2000, confidence=0.95){ # Initial ratio of positive documents
  # This is the function that is called from Python
  # Gather the positive part of the table
  df.pos <- freq.df %>% filter(positive==1)
  # Calculate the number of positive documents
  count.found <- sum(df.pos$count)
  
  # Fit the initial model through EM
  model <- rasch.em.comb(freq.df, N, proportion=proportion)
  fv <- fitted(model) %>% unlist(use.names=F) %>% as.vector()
  model.estimates <-  tail(fv, 2)
  # Return the estimated number of positive documents
  model.estimate.pos <- count.found + model.estimates[1]
  # Calculate the confidence interval
  counts.bootstrap <- rmultinom(it, N, fv)
  df <- df.modify(freq.df, NA, NA)
  s <- c(
    rep(T, nrow(freq.df)), # Do not contain n_00...0
    rep(F, nrow(df) - nrow(freq.df)) #Do contain n_00...0
  )
  estimates <- list()
  for (col.idx in 1:dim(counts.bootstrap)[2]) {
    count.bootstrap <- counts.bootstrap[,col.idx]
    df.adjusted <- df
    df.adjusted$count <- count.bootstrap
    bootstrap.model <- glm(count ~ ., "poisson", df.adjusted)
    bootstrap.fv <- fitted(bootstrap.model) %>% unlist(use.names=F) %>% as.vector()
    # Estimates for n00...0 are located at the last two members of the list
    bootstrap.estimates <- tail(bootstrap.fv, 2)
    # Return the estimated number of positive documents
    estimates[[col.idx]] <- count.found + bootstrap.estimates[1]
  }
  results <- unlist(estimates, use.names = F)
  sorted <- sort(results)
  bounds <- unlist(quantile(sorted, c(1-confidence, confidence)), use.names=F)
  result.df <- data.frame(
    estimate = model.estimate.pos,
    lowerbound = bounds[1],
    upperbound = bounds[2])
  return(result.df)
}


rasch.em.ms <- function(f.em, freq.df, N){
  lowest <- f.em(freq.df, N, proportion=0.5)
  proportions = c(0.0001, 0.001, 0.01, 0.1, 0.3, 0.5, 0.8, 0)
  for(pp in proportions){
    result <- f.em(freq.df, N, proportion=pp)
    if(lowest$deviance > result$deviance){
      lowest <- result
    }
  }
  return(lowest)
}


rasch.ridge.em.horizon <- function(freq.df, # The dataframe (from python or rasch.csv)
                             N, # The dataset size 
                             proportion=0.1){ # Initial ratio of positive documents
  # This is the function that is called from Python
  # Gather the positive part of the table
  df.pos <- freq.df %>% filter(positive==1)
  # Calculate the number of positive documents
  count.found <- sum(df.pos$count)
  results <- rasch.em.ms(rasch.ridge.em.comb, freq.df, N)
  # Return the estimated number of positive documents
  df <- data.frame(estimate=count.found + results$est.pos)
  return(df)
}
rasch.ridge.em.horizon.parametric <- function(freq.df, # The dataframe (from python or rasch.csv)
                                   N, # The dataset size 
                                   it=100, confidence=0.95){ # Initial ratio of positive documents
  
  # Store the original freq.df
  orig.df <- freq.df
  
  # Find the prediction value
  results <- rasch.ridge.em.horizon(freq.df, N)
  est.pos <- results[1,1]

  # This is the function that is called from Python
  # Gather the positive part of the table
  df.pos <- freq.df %>% filter(positive==1)
  df.neg <- freq.df %>% filter(positive==0)
  # Calculate the number of positive documents
  count.found <- sum(df.pos$count)
  
  counts.model <- append(freq.df$count, est.pos)
  counts.model.sum <- sum(counts.model)
  # Sample with replacement of size n from this multinomial distribution. 
  # Remove the observation that correspond with cell 00..0. 
  counts.bootstrap <- rmultinom(it, 
                                counts.model.sum, 
                                counts.model) %>% head(-1)
  # Calculate the n_00...0 for all the bootstrap counts
  estimates <- list()
  for (col.idx in 1:dim(counts.bootstrap)[2]) {
    count.bootstrap <- counts.bootstrap[,col.idx]
    df.adjusted <- orig.df
    df.adjusted$count <- count.bootstrap
    model.results <- rasch.ridge.em.horizon(df.adjusted, N)
    estimates[[col.idx]] <- model.results[1,1]
  }
  # Determine using the percentile method a 
  # 95% confidence interval
  results <- unlist(estimates, use.names = F)
  sorted <- sort(results)
  bounds <- unlist(quantile(sorted, c(1-confidence, confidence)), use.names=F)
  result.df <- data.frame(
    estimate = est.pos,
    lowerbound = bounds[1],
    upperbound = bounds[2]
  )
  return(result.df)
  
  # Return the estimated number of positive documents
  df <- data.frame(estimate=count.found + results$est.pos)
  return(df)
}

library(tidyverse)

rasch.estimate <- function(df, count.expectation){
  df.t <- as_tibble(df)
  df.m <- df.t %>% 
            add_row(count=count.expectation) %>% 
            mutate_all(
              ~replace(., is.na(.), 0)
            )
  model <- glm(
    formula = count ~ ., 
    family = poisson(link = "log"), 
    data = df.m
  )
  # Get the coefficients from the model
  coefficients <- coef(model) %>% unlist(use.names = F)
  stderrs = sqrt(diag(vcov(model))) %>% unlist(use.names = F)
  
  # Get the intercept of the formula (the estimate is exp(intercept))
  intercept = coefficients[1]
  intercept.err = stderrs[1]
  
  # Calculate the number of missing papers
  estimate.missing = exp(intercept)
  ret <- list(
    estimate.missing=estimate.missing,
    deviance=model$deviance)
  return(ret)
}
create.design.matrix<- function(learners){
  learners.n <- dim(learners)
  
}

rasch.expectation <- function(df.pos, df.neg, dataset.size, missing.pos, missing.neg){
  count.read <- sum(df.pos$count) + sum(df.neg$count)
  count.unread <- dataset.size - count.read
  random.partition <- rmultinom(1, count.unread, c(missing.pos, missing.neg))
  return(list(missing.pos=random.partition[1], missing.neg=random.partition[2]))
}

rasch.maximization <- function(df.pos, df.neg, dataset.size, missing.pos, missing.neg){
  estimate.pos <- rasch.estimate(df.pos, missing.pos)
  estimate.neg <- rasch.estimate(df.neg, missing.neg)
  deviance <- rasch.estimate(df.pos, missing.)
  return(list(missing.pos=estimate.pos, missing.neg=estimate.neg))
}
calculate.ratio <- function(exp.r){
  ratio <- exp.r$missing.pos / (exp.r$missing.pos + exp.r$missing.neg)
  return(ratio) 
}

rasch.em <- function(df.pos, df.neg, dataset.size, missing.pos=1, missing.neg=1, maxit=1000, epsilon=1e-5){
  converged <- FALSE
  
  e.result <- list(missing.pos=missing.pos, missing.neg=missing.neg)
  m.result <- list(missing.pos=missing.pos, missing.neg=missing.neg)
  
  e.results <- list()
  m.results <- list()
  i.max <- 1
  
  for(i in 1:maxit){
    m.result.prev <- m.result
    e.result.prev <- e.result
    
    e.ratio.prev <- calculate.ratio(e.result.prev)
    m.ratio.prev <- calculate.ratio(m.result.prev)
    
    e.result <- rasch.expectation(
      df.pos, df.neg, dataset.size, 
      m.result$missing.pos, m.result$missing.neg)
    m.result <- rasch.maximization(
      df.pos, df.neg, dataset.size, 
      e.result$missing.pos, e.result$missing.neg)

    e.ratio <- calculate.ratio(e.result)
    m.ratio <- calculate.ratio(m.result)
    
    if(abs(e.ratio - m.ratio) < epsilon){
      converged <- TRUE
      break
    }
  
    e.results[[i]] <- e.ratio
    m.results[[i]] <- m.ratio
    i.max <- i
  }
  if(!converged){
    warning("Did not converge")
  }
  result.list <- list(
    df = data.frame(
      pos_estimate = m.result$missing.pos,
      neg_estimate = m.result$missing.neg),
    ratios.e = unlist(e.results),
    ratios.m = unlist(m.results)
  )
  return(result.list$df)
}

df.modify <- function(freq.df, n.pos, n.neg){
  # From Python the rows for n_00...0 are missing
  # We add them with the following statement
  df <- freq.df %>% 
    add_row(count=n.pos, positive=1) %>%
    add_row(count=n.neg, positive=0) %>%
    mutate_at(vars(-c("count")), ~replace(., is.na(.), 0))
  return(df)
}

rasch.em.comb <- function(freq.df, N, proportion=0.05, tolerance=1e-6){
  # Calculate the start values for the n.pos and n.neg
  n.pos   <- round(proportion*N)
  n.neg   <- round((1-proportion)*N)
  
  # Add the missing rows for n_00...0
  df      <- df.modify(freq.df, n.pos, n.neg)
  s       <- c(
    rep(T, nrow(freq.df)), # Do not contain n_00...0
    rep(F, nrow(df) - nrow(freq.df)) #Do contain n_00...0
  )
  N0      <- N - sum(df$count[s]) # The number of documents that are not read
  # Copy the data frame to new variable that can be manipulated
  df.em     <- df 
  
  # Fit initial log linear model and calculate deviance
  mstep   <- glm(count ~ ., "poisson", df.em)
  devold  <- mstep$deviance
  tol <- devold
  
  while(tol > tolerance){
    # Calculate fitted frequencies
    mfit  <- fitted(mstep, "response")
    
    # Adjust the frequencies for n_00...0
    efit  <- df.em$count
    efit[!s] <- mfit[!s] * N0 / sum(mfit[!s]) 
    
    # Store new frequencies in data frame
    df.em$count <- efit
    
    # Fit log linear model and calculate deviance
    mstep <- glm(count ~ ., "poisson", df.em)
    devnew <- mstep$deviance
    
    # Determine if we have converged
    tol <- devold - mstep$deviance
    devold <- mstep$deviance
  }
  return(mstep)
}
rasch.csv <- function(filename){
  df <- read_csv(filename, col_types = cols(X1= col_skip()))
  return(df)
}
rasch.em.horizon <- function(freq.df, N, proportion=0.05){
  # This is the function that is called from Python
  # Gather the positive part of the table
  df.pos <- freq.df %>% filter(positive==1)
  # Calculate the number of positive documents
  count.found <- sum(df.pos$count)
  model <- rasch.em.comb(freq.df, N, proportion=proportion)
  fv <- fitted(model) %>% unlist(use.names=F) %>% as.vector()
  # Estimates for n00...0 are located at the last two members of the list
  estimates <-  tail(fv, 2)
  # Return the estimated number of positive documents
  df <- data.frame(estimate=count.found + estimates[1])
  return(df)
}

#!/bin/bash
# Our custom function
run_benchmark(){
  python -m allib ./datasets/Nagtegaal_2019.csv ./results NaiveBayesEstimator TfIDF5000
}
for i in {1..10}
do
	run_benchmark
done
 
## Put all cust_func in the background and bash 
## would wait until those are completed 
## before displaying all done message
wait 
echo "All done"
